# include	<string.h>
# include	"ColorException.h"
# include	"Spectrum.h"

namespace	ColorimetrySpace
{

Spectrum::Spectrum(register const SpectrumData Table [],
	register unsigned int Elements, float thisWaveStep,
	SpectrumType thisKind) noexcept(false): NumValues(Elements)
	{
	Data = static_cast<SpectrumData*>(memcpy(new SpectrumData [Elements],
		Table, Elements * sizeof(SpectrumData)));
	WaveStep = thisWaveStep;
	Kind = thisKind;
	}

Spectrum::~Spectrum(void) noexcept
	{
	delete [] Data;
	}

unsigned int	Spectrum::GetNumValues(void) const noexcept
	{
	return NumValues;
	}

float	Spectrum::GetValue(unsigned int Index) const noexcept(false)
	{
	if (Index >= NumValues)
		throw ColorExceptionType::InvalidIndex;
	return Data [Index].Value;
	}

}
