# if	!defined	SPECTRUM_H
# define	SPECTRUM_H

namespace	ColorimetrySpace
{

enum	class	SpectrumType { Generic, Power, Reflectance };

struct	SpectrumData
	{
	float	WaveLength;
	float	Value;
	};

class	Spectrum
	{
	private:
		SpectrumData*	Data;
		float		WaveStep;
		SpectrumType	Kind;
		unsigned int	NumValues;

	public:
				Spectrum(register const SpectrumData Table [],
					register unsigned int Elements,
					float thisWaveStep,
					SpectrumType thisKind) noexcept(false);
				Spectrum(const Spectrum& thisSpectrum) = delete;
				Spectrum(Spectrum&& thisSpectrum) = delete;
		Spectrum&	operator = (const Spectrum& thisSpectrum) =
					delete;
		Spectrum&	operator = (Spectrum&& thisSpectrum) = delete;
				~Spectrum(void) noexcept;
		unsigned int	GetNumValues(void) const noexcept;
		float		GetValue(unsigned int Index) const
					noexcept(false);

	};

}

# endif
